<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"   "http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<title>dsSvrMailer User Email Contact Utility</title>

<!-- 
	University of Illinois/NCSA Open Source License for dsbrun.php.

Copyright (c) 2008 Jim Champ/Surrey County Council 
All rights reserved.
Developed by: 		Jim Champ
                    www.devboats.co.uk/idmphp/
Permission is hereby granted, free of charge, to any person obtaining a
copy of this software and associated documentation files (the
"Software"), to deal with the Software without restriction, including
without limitation the rights to use, copy, modify, merge, publish,
distribute, sublicense, and/or sell copies of the Software, and to
permit persons to whom the Software is furnished to do so, subject to
the following conditions:

Redistributions of source code must retain the above copyright
notice, this list of conditions and the following disclaimers. 

Redistributions in binary form must reproduce the above
copyright notice, this list of conditions and the following disclaimers
in the documentation and/or other materials provided with the
distribution. 

Neither the names of Surrey County Council nor the names of its contributors may be used to endorse
or promote products derived from this Software without specific prior
written permission. 
THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
IN NO EVENT SHALL THE CONTRIBUTORS OR COPYRIGHT HOLDERS BE LIABLE FOR
ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
SOFTWARE OR THE USE OR OTHER DEALINGS WITH THE SOFTWARE. 
*/
-->
</head>
<body>

<h1>User Email Contact Utility</h1>

<?php 
// some behaviour variables
// Set this to true if you wish to use a separate LDAP server to look up email addresses,
// false if you want to take email addresses from the File and Print Directory...
$UseSeparateEmailLDAP = true;
$LookUpAuthorEmailinLDAP = true;
$default_reply_email = "noreply@yourdomain.com";

//now get the variables from the form
if (@$_POST['edir_ldap_id'] > "" ) {
	// newer systems support the _post system for posted variable
	// older ones http_post_vars so we test for both...
	$edir_ldap_id=$_POST['edir_ldap_id'];
	$edir_ldap_cx=$_POST['edir_ldap_cx'];
	$edir_ldap_pw=$_POST['edir_ldap_pw'];
	$edir_ldap_server=$_POST['edir_ldap_server'];
	$edir_search_ou=$_POST['search_ou'];
	$mail_type=strtolower($_POST['mail_type']);
	$mail_title=$_POST['mail_title'];
	$mail_text=$_POST['mail_text'];
	$search_type=strtolower($_POST['search_type']);
	$svr_name=strtolower($_POST['svr_name']);
} else {
	if ($HTTP_POST_VARS['edir_ldap_id'] > "" ) {
		$edir_ldap_id=$HTTP_POST_VARS['edir_ldap_id'];
		$edir_ldap_cx=$HTTP_POST_VARS['edir_ldap_cx'];
		$edir_ldap_pw=$HTTP_POST_VARS['edir_ldap_pw'];
		$edir_ldap_server=$HTTP_POST_VARS['edir_ldap_server'];
		$edir_search_ou=$HTTP_POST_VARS['search_ou'];
		$mail_type=strtolower($HTTP_POST_VARS['mail_type']);
		$mail_title=$HTTP_POST_VARS['mail_title'];
		$mail_text=$HTTP_POST_VARS['mail_text'];
		$search_type=strtolower($HTTP_POST_VARS['search_type']);
		$svr_name=strtolower($HTTP_POST_VARS['svr_name']);
	} else {
		echo " <h2>dssvrmailer.php must be run from svrmailer.php</h2>\n";
		echo "<p>Please select <a href=\"svrmailer.php\"> this link to run the mailer utility.</p>";
						closedocument();
		exit;
	}
}

echo "<h3>Email addresses for users under context" . $edir_search_ou . "</h3>\n";
if($search_type=="homedir"){
	echo "<h4>Listing only users with Home Directory on Server " . $svr_name . "</h4><br>\n";
}
//This is the authentication for the email LDAP
// it could be skipped with an if statement if you want to be
// very neat
$mail_ldap_pw = "";
$mail_ldap_server = "ldap@yourdomain.com";
$mail_ldap_root = "";
$mail_ldap_id = "cn=admin,o=yourdomain" ;

// format some variables
$author_id = $edir_ldap_id;
$edir_ldap_id="cn=" . $edir_ldap_id . "," . $edir_ldap_cx;
$edir_ldap_sr="SN=*" ;


if ($UseSeparateEmailLDAP){
	// basic sequence with LDAP is connect, bind, search, interpret search
	// result, close connection
	// So we start by connecting to LDAP
	// we are going to want to LDAP email addresses , so lets open up the LDAP server...
	echo "Connecting to Mail LDAP server...";
	$mail_ds=@ldap_connect("$mail_ldap_server");  // must be a valid LDAP server!
	//echo "Post Connect\n";
	if(@ldap_bind($mail_ds, $mail_ldap_id,$mail_ldap_pw)) {
		echo "... succeeded.<br>\n";
		// we have now made an LDAP connection
	} else {
		echo " failed.</p>\n<h2>LDAP Authentication to mail directory Failed</h2>\n";
		echo "<p>User id and/or Password credentials are incorrect in the script.</p>\n";
		echo "<p>Your system administrator is responsible for correcting this.</p>\n";
		exit;
	}
}

echo "<p>Connecting to Edir LDAP server...  ";

$edir_ds=ldap_connect("$edir_ldap_server");  // must be a valid LDAP server!

if(@ldap_bind($edir_ds, $edir_ldap_id,$edir_ldap_pw)) {
	echo " ...succeeded<br>\n";
	// we have now made an LDAP connection

} else {
	echo " failed.</p>\n<h2>LDAP Authentication to eDirectory Failed</h2>\n";
	echo "<p>User id and/or Password credentials were incorrect</p>\n";
	echo "<p>User id and context entered was " . $edir_ldap_id . "</p>\n";
	echo "<p>Use back to go back to the form and renter the LDAP user id and password. Make sure that you used ";
	echo "correct LDAP syntax (ou=unit,o=org) rather than NDS syntax for the user context.</p>\n";
	exit;
	
}

// Lets get the email address of the author...
// we use this for the source addr of the email...
if ($LookUpAuthorEmailinLDAP) {
	if ($UseSeparateEmailLDAP){
		//echo "Searching for Author email...<br>";
		$mail_ldap_sr = "cn=" . $author_id;
		$mail_sr=@ldap_search($mail_ds, $mail_ldap_root, $mail_ldap_sr, array(cn,mail,eMailAddress,surname,givenName) );
		$mail_entry = @ldap_first_entry($mail_ds, $mail_sr);
		$mail_ldap_returns = 0;
		$mail_ldap_returns = @ldap_count_entries($mail_ds, $mail_sr);
		$mail_attrs = @ldap_get_attributes($mail_ds,$mail_entry);
		//echo "Author Ldap Query\n";
		
		// We only use the email details from LDAP if there was a single return to the
		// LDAP Query... More or less means we shouldn't trust the adddresses - or even know which one to use!
		if ($mail_ldap_returns = 1) {
			// get the email details in the fields
			//echo "Address Returned...<br>";
			$mail_From =  @$mail_attrs["mail"][0] ;
		}
	} else {
		// we look up the mail attributte of the author in the eDirectory LDAP
		$edir_ldap_sr = "cn=" . $author_id;
		//note the subtle difference here  to main code further on, ldap search
		// is in the author context, not the search context
		$edir_sr=@ldap_search($edir_ds, $edir_ldap_cx, $edir_ldap_sr, array(cn,mail,eMailAddress,surname,givenName) );
		$edir_entry = @ldap_first_entry($edir_ds, $edir_sr);
		$edir_ldap_returns = 0;
		$edir_ldap_returns = @ldap_count_entries($edir_ds, $edir_sr);
		$edir_attrs = @ldap_get_attributes($edir_ds,$edir_entry);
		// echo "Searching for Author Email in eDirectory...<br>\n";
		
		// We only use the email details from LDAP if there was a single return to the
		// LDAP Query... More or less means we shouldn't trust the adddresses - or even know which one to use!
		if ($edir_ldap_returns = 1) {
			// get the email details in the fields
			$mail_From =  @$edir_attrs["mail"][0] ;
		}
	}
} 
//if this hasn't got some kind of email adress back or we haven't chosen to
// look up the email address then use the default to reply...

if (strlen($mail_From) < 2){
		$mail_From =  $default_reply_email ;
}

if($mail_type == "useform") {
	echo "Return Email address is: " . $mail_From . "</br>\n";
}

$mailheaders = "From: " . $mail_From . "\r\n" . "Reply-To: " . $mail_From . "\r\n" . "X-Mailer: PHP/" . phpversion();
ini_set("SMTP","outmail.yourdomain.com" ); 

// OK now its time to search the edir LDAP for all users that come within our scope... 
$edir_sr=@ldap_search($edir_ds, $edir_search_ou, $edir_ldap_sr, array(cn,mail,eMailAddress,surname,givenName,ndsHomeDirectory) );
$edir_entry = @ldap_first_entry($edir_ds, $edir_sr);

// and report on the return from LDAP...
if(@ldap_count_entries($edir_ds, $edir_sr) == 1 ) {
	echo  "1 directory entry returned.</p>\n";
} else {
	echo  @ldap_count_entries($edir_ds, $edir_sr) . " directory entries returned.</p>\n";
}

// now we iterate through all returned entries to process...
while ($edir_entry) {
	$attrs = @ldap_get_attributes($edir_ds,$edir_entry);
	$cn =  @$attrs["cn"][0];
	$edir_mail =  @$attrs["mail"][0];
	
	if ($UseSeparateEmailLDAP){
		// here we want to go LDAP up the new owner email address,
		// close off the previous message and email, start the next message, all that...
		// echo "Running the LDAP Search...\n";
		// do the search
		$mail_ldap_sr = "cn=" . $cn;
		$mail_sr=@ldap_search($mail_ds, $mail_ldap_root, $mail_ldap_sr, array(cn,mail,eMailAddress,surname,) );
		$mail_entry = @ldap_first_entry($mail_ds, $mail_sr);
		$mail_ldap_returns = 0;
		$mail_ldap_returns = @ldap_count_entries($mail_ds, $mail_sr);
		$mail_attrs = @ldap_get_attributes($mail_ds,$mail_entry);
		// echo "Ldap Query\n";
		// LDAP Query... More or less means we shouldn't trust the adddresses - or even know which one to use!
		if ($mail_ldap_returns = 1) {
			// get the email details in the fields
			$Email =  @$mail_attrs["mail"][0] ;
		}
	}

	if (strlen($Email)> 3)  {
		// we check length of email address - it shoud have returned from LDAP or it could be blank
		//  less than 3 chars even if presentis going to be invalid
		// and it will be blank if we didn't use the email server lookup option
		// so this is a do nothing branch!
	} else {
		// we have no returned email address
		// so we set Email to be the value from NDS - if any...
		//we don't bother to trap for no edir value - this will be dealt with later 
		$Email = $edir_mail;
	}

	if($search_type=="homedir"){
		// here we wish to extract the server name from the home directory attribute
		// take cn= off the front and pick the volume off with the _
		// server names with underscores in will cause problems (are they legal?)
		// if you have them you will need to create some smarter code here
		//echo "Raw homedir value is " . @$attrs["ndsHomeDirectory"][0] . "<br>\n";
		$hcxt =  strtolower(trim(substr(@$attrs["ndsHomeDirectory"][0], 3, strpos($attrs["ndsHomeDirectory"][0], "_")-3)));
			
		if($svr_name == $hcxt) {
			// echo "HomeDir Matched<br>";
			if($mail_type == "useform") {
				// mail off the mail form to $Email
				if (strlen($Email) > 3) {
					//echo "To: " . $Email ."<br>\nTitle: " . $mail_title . "<br>\n" .$mail_text . "<br>\nfrom : " .$mailheaders . "<br><br>\n";
					echo "Email sent to " . $Email . ".</br>\n";	
					mail ($Email,$mail_title,$mail_text,$mailheaders);
				} else {
						echo "No Email found for user " . $cn . "<br>\n";
				}
			} else {
				// report email address...
				if (strlen($Email) > 3) {
					echo  $Email . "<br>\n";
				} else {
					// if there is no email set we just quietly skip this entry
					// you could report to screen if you are concerned or want to take the opportunity to
					// data cleanse the mail directory
				}
			}
			// here if there is no email set we print a blank line
			// you could report to screen if you are concerned or want to take the opportunity to
			// data cleanse the mail directory
		} else {
			//echo "Homedir unmatched for user " . $cn . ", their homedir is on " . $hcxt . "<br>\n";
			// this choice is left because its handy for debugging.
			// I don't think it will ever be useful to report when homeidr isn't matched
			// because that's the whole point!
		}
	} else {
		if($mail_type == "useform") {
			// mail off the mail form to $Email
			if (strlen($Email) > 3) {
				//echo "To: " . $Email ."<br>\nTitle: " . $mail_title . "<br>\n" .$mail_text . "<br>\nfrom : " .$mailheaders . "<br><br>\n";
				echo "Email sent to " . $Email . ".</br>\n";	
				mail ($Email,$mail_title,$mail_text,$mailheaders);
			} else {
				// if there is no email set we just quietly skip this entry
				// you could report to screen if you are concerned or want to take the opportunity to
				// data cleanse the mail directory
			}
		} else {
			if (strlen($Email) > 3) {
				// report email address...
				echo  $Email . "<br>\n";
			}
		}
	}
	$edir_entry = ldap_next_entry($edir_ds, $edir_entry);
	//echo "Reading Next entry...<br>";
}
//now close the ldap connections
ldap_close($edir_ds);
if ($UseSeparateEmailLDAP){
	ldap_close($mail_ds);
} 

if($mail_type == "useform") {
	echo "</p>\n<p>Finished sending Emails.</p>\n";
} else {
	echo "</p>\n<p>Email List complete.</p>\n";
}

?>

</body>
</html>
